<!-- PERSONAL INFO FORM -->
<!--[formGroup]="roleAndLocationFormGroup"-->
<form>
  <mat-expansion-panel expanded="true">
    <mat-expansion-panel-header class="mb-0">
      <mat-panel-title>
        Role & Locations
      </mat-panel-title>
    </mat-expansion-panel-header>

    <div class="row pt-1">
      <div class="col-12" [formGroup]="fg" *ngFor="let fg of roleAndLocationFormArray?.controls; let i = index;">
        <mat-divider *ngIf="i > 0" style="margin: 0 -24px; margin-bottom: 8px;"
                     [class.mt-29px]="isValidForSchedulerAccess(i-1) && !isValidForPractitionerDetails(i - 1)"></mat-divider>
        <!-- Location & Role Fields -->
        <div class="row" [class.mt-2]="i == 1">

          <!-- Location Field -->
          <div class="col-4 pr-0">
            <div class="required-label-top text-right">
              Required
            </div>
            <mat-form-field [appearance]="appearance">
              <mat-label>Location</mat-label>
              <mat-select formControlName="locationId" class="normal_16px_font" [disabled]="i == 0"
                          [class.remove-arrow]="i == 0">
                <ng-container *ngFor="let location of locations;">
                  <mat-option *ngIf="isDisplayThisLocation(location.id, i)"
                              [value]="location.id"> {{location.locationName}}</mat-option>
                </ng-container>
              </mat-select>
              <mat-error *ngIf="fg.get('locationId').hasError('required') && fg.get('locationId').touched">
                This field is required
              </mat-error>
            </mat-form-field>
          </div>

          <!-- Roles Field -->
          <div class="col-8">
            <div class="required-label-top text-right">
              Required
            </div>
            <mat-form-field [appearance]="appearance">
              <mat-label>Role</mat-label>
              <app-kendo-multi-select #select formControlName="selectedRoles" [clearButton]="!ownerRoleId"
                                      [disabledTagsVal]="ownerRoleId ? [ownerRoleId] : []" [isDisabledTag]="true"
                                      [data]="roles" [textField]="'roleName'" [valueField]="'id'"
                                      (valueChanged)="onSelectRole($event, i)"></app-kendo-multi-select>
              <div matSuffix class="d-flex align-items-center" (click)="select.toggle()">
                <img src="./assets/ic-search-blue.png"/>
                <div class="mat-select-arrow ml-2"></div>
              </div>
              <mat-error *ngIf="fg.get('selectedRoles').hasError('required')">
                This field is required
              </mat-error>
            </mat-form-field>
          </div>

        </div>

        <!-- Scheduler Access Field Section -->
        <div class="row">
          <div class="col-12">
            <mat-form-field [appearance]="appearance" *ngIf="isValidForSchedulerAccess(i)">
              <mat-label>Scheduler Access</mat-label>
              <app-kendo-multi-select #select formControlName="selectedPractitioner" [textField]="'fullName'"
                                      [valueField]="'id'" [data]="getPractitionerById(fg.get('locationId').value)"
                                      (valueChanged)="onSelectPttrForSchedulerAccess($event, i)"></app-kendo-multi-select>
              <div matSuffix class="d-flex align-items-center" (click)="select.toggle()">
                <img src="./assets/ic-search-blue.png"/>
                <div class="mat-select-arrow ml-2"></div>
              </div>
              <mat-hint>Only the selected Practitioner’s bookings will be shown in your Appointment Scheduler.
              </mat-hint>
            </mat-form-field>
          </div>
        </div>

        <!-- Practitioner Details -->
        <div class="practitioner-details-container" style="margin-top: 14px;" *ngIf="isValidForPractitionerDetails(i)">
          <div class="practitioner-details-header d-flex align-items-center">
            <div class="flex-fill">
              <div class="pttr-details-text helvetica-neue-regular">Practitioner Details</div>
            </div>

            <a *ngIf="specialities.value && specialities.value.length > 0" role="button"
               class="other-ids-text helvetica-neue-regular" (click)="openOtherIdDialog(i)">
              Other ID's
            </a>
          </div>

          <div class="row" style="margin-top: 22px;">
            <!-- SERVICE TYPE -->
            <div class="col-6 pr-0">
              <mat-form-field [appearance]="appearance">
                <mat-label>Service Type</mat-label>
                <mat-select class="normal_16px_font" #serviceType
                            (selectionChange)="serviceTypeSelectionChange($event, i)">
                  <mat-option *ngFor="let serviceType of serviceTypes;"
                              [value]="serviceType.id"> {{serviceType.serviceName}}</mat-option>
                </mat-select>
              </mat-form-field>
            </div>

            <!-- SPECIALITIES MULTI SELECT -->
            <div class="col-6">
              <div class="required-label-top-container text-right w-100" style="margin-top: -22px;">
                <div class="required-label-top">Required</div>
              </div>
              <mat-form-field [appearance]="appearance">
                <mat-label>Speciality</mat-label>
                <app-kendo-multi-select #specialities formControlName="selectedSpecialities" [filterable]="true"
                                        [textField]="'specialityName'" [valueField]="'id'"
                                        [data]="getSpecialitiesByLocationId(i)"
                                        (removeTag)="onRemoveSpecialities($event, i)"
                                        (valueChanged)="onSelectSpecialities($event, serviceType.value, i)"></app-kendo-multi-select>
                <div matSuffix class="d-flex align-items-center" (click)="specialities.toggle()">
                  <img src="./assets/ic-search-blue.png"/>
                  <div class="mat-select-arrow ml-2"></div>
                </div>
                <mat-error
                  *ngIf="fg.get('selectedSpecialities').hasError('required') && fg.get('selectedSpecialities').touched">
                  This field is required
                </mat-error>
              </mat-form-field>
            </div>
          </div>

          <div class="row" [formGroup]="spOiFG" *ngFor="let spOiFG of getFormForSpecialitiesAndOtherId(i)?.controls">
            <ng-container *ngIf="spOiFG.get('type')?.value === 0">
              <!-- List All Selected Specialities One By One with Provider Number -->
              <div class="col-6 pr-0" [class.col-12]="country && country.toLowerCase() != 'australia'">
                <mat-form-field [appearance]="appearance">
                  <mat-label>Speciality</mat-label>
                  <input matInput formControlName="specialityName" type="text"/>
                </mat-form-field>
              </div>

              <!-- Provider Number -->
              <div class="col-6" *ngIf="country && country.toLowerCase() == 'australia'">
<!--                <div class="required-label-top-container text-right w-100" style="margin-top: -22px;">-->
<!--                  <div class="required-label-top">Required</div>-->
<!--                </div>-->
                <mat-form-field [appearance]="appearance">
                  <mat-label>Provider Number</mat-label>
                  <input matInput formControlName="providerNumber" type="text" />
<!--                  <mat-error *ngIf="spOiFG.get('providerNumber')?.hasError('required')">-->
<!--                    This field is required-->
<!--                  </mat-error>-->
                  <mat-error *ngIf="spOiFG.get('providerNumber')?.hasError('invalid')">
                    Please enter valid provider number.
                  </mat-error>
                </mat-form-field>
              </div>
            </ng-container>
          </div>
        </div>

        <div class="row mb-2" *ngIf="i > 0">
          <div class="col-12">
            <button class="no-border-bg-btn" (click)="removeUserLocationAndRoleForm(i)">
              <img class="mr-2" src="./assets/ic-remove-row-other-id.png"/>
              <a role="button">Remove Location</a>
            </button>
          </div>
        </div>
      </div>

      <div class="col-12 text-right mt-2"
           *ngIf="roleAndLocationFormArray && locations && roleAndLocationFormArray.length < locations.length">
        <button mat-stroked-button color="accent" (click)="addUserLocationAndRoleForm()">
          Assign another Location
        </button>
      </div>
    </div>

  </mat-expansion-panel>
</form>

<!-- DIALOG -->
<kendo-dialog *ngIf="isOtherIdDialogOpen" [width]="778" [height]="'auto'">

  <div class="h-100 position-relative" style="padding: 0 4px">
    <div class="d-flex align-items-center" style="height: 40px; min-height: 40px;">
      <div class="dialog-title text-uppercase flex-fill quicksand normal_18px_font text-black">
        PRACTITIONER OTHER ID's
      </div>
      <button mat-icon-button class="modalClosebtn" (click)="closeOtherIdDialog()"
              style="width: 24px; height: 24px; line-height: 24px; margin-right: 10px;" aria-label="Close dialog">
        <mat-icon class="m-0">close</mat-icon>
      </button>
    </div>
    <mat-divider></mat-divider>

    <div
      style="height: calc(100% - 114px); max-height: 540px; min-height: 200px; padding: 10px 0; overflow: hidden; overflow-y: auto;">
      <div class="text-black normal_16px_19px_font helvetica-neue-regular">You can add Practitioner related ID’s here.
      </div>

      <div style="margin-top: 24px;">
        <div class="d-flex align-items-center" [formGroup]="fg"
             *ngFor="let fg of otherIdsFormArray.controls; let i=index;">
          <!-- Specialities -->
          <div class="other-id-dialog-field-wrapper">
            <div class="required-label-top-container text-right w-100">
              <div class="required-label-top">Required</div>
            </div>
            <mat-form-field [appearance]="appearance">
              <mat-label>Speciality</mat-label>
              <mat-select formControlName="specialityId">
                <mat-option *ngFor="let data of otherIDsSpecialities" [value]="data.specialityId">
                  {{data.specialityName}}
                </mat-option>
              </mat-select>
            </mat-form-field>
          </div>

          <!-- Id Name -->
          <div class="other-id-dialog-field-wrapper ml-2">
            <div class="required-label-top-container text-right w-100">
              <div class="required-label-top">Required</div>
            </div>
            <mat-form-field [appearance]="appearance">
              <mat-label>ID Name</mat-label>
              <app-add-new-dropdown formControlName="otherIdName"
                                    [categoryId]="STAFF_OTHER_ID_NAME"></app-add-new-dropdown>
            </mat-form-field>
          </div>

          <!-- ID Number -->
          <div class="other-id-dialog-field-wrapper ml-2">
            <div class="required-label-top-container text-right w-100">
              <div class="required-label-top">Required</div>
            </div>
            <mat-form-field [appearance]="appearance">
              <mat-label>ID No.</mat-label>
              <input matInput formControlName="otherID" type="text"/>
            </mat-form-field>
          </div>

          <!-- Remove This Row -->
          <div *ngIf="i > 0 || (fg.get('specialityId').value || fg.get('otherIdName').value || fg.get('otherID').value)"
               class="other-id-dialog-field-wrapper ml-2 d-flex align-items-center"
               style="padding-bottom: 20px; height: 80.31px;">
            <button class="no-border-bg-btn" (click)="removeOtherIdsPopupFormGroup(i)">
              <img src="./assets/ic-remove-row-other-id.png"/>
            </button>
          </div>

        </div>
      </div>

      <div class="text-left w-100">
        <button class="no-border-bg-btn" (click)="addOtherIdsPopupFormGroup()">
          <img src="./assets/ic-add-row-other-id.png"/>
        </button>
      </div>
    </div>

    <div class="text-right w-100" style="bottom: 0;margin-top: 10px;">
      <mat-divider></mat-divider>
      <div class="text-right" style="margin-top: 19px;">
        <button mat-stroked-button color="accent" class="mr-3 cancelbuttons btnheight dialog-btn"
                (click)="closeOtherIdDialog()">
          Cancel
        </button>
        <button mat-raised-button color="accent" class="btnheight dialog-btn" (click)="applyOtherId()">
          Apply
        </button>
      </div>
    </div>
  </div>

</kendo-dialog>
<!-- DIALOG -->

<!-- DIALOG -->
<kendo-dialog *ngIf="isOpenConfirmAlertDialog" [height]="299" [width]="778">

  <div style="padding: 0 4px">
    <div class="d-flex align-items-center" style="height: 40px; min-height: 40px;">
      <button class="no-border-bg-btn">
        <img src="./assets/alert.png"/>
      </button>
      <div class="dialog-title text-uppercase flex-fill">
        <span>{{confirmAlertDialogTitle}}</span>
      </div>
      <button mat-icon-button class="modalClosebtn" (click)="closeConfirmAlertDialog()"
              style="width: 24px; height: 24px; line-height: 24px; margin-right: 10px;" aria-label="Close dialog">
        <mat-icon class="m-0">close</mat-icon>
      </button>
    </div>
    <mat-divider></mat-divider>

    <div class="normal_16px_font normalhelfont lightcolor"
         style="height: 141px; letter-spacing: 0.15px; padding: 20px 0; white-space: break-spaces;"
         [innerHtml]="confirmAlertDialogDesc">
    </div>

    <mat-divider></mat-divider>
    <div class="text-right w-100" style="margin-top: 19px;">
      <button *ngIf="isCancelOpenConfirmAlertDialog" mat-stroked-button color="accent"
              class="mr-3 cancelbuttons btnheight dialog-btn" (click)="closeConfirmAlertDialog()">
        <span>{{confirmAlertDialogCancelText}}</span>
      </button>
      <button mat-raised-button color="accent" class="btnheight dialog-btn" (click)="clickConfirmAlertOk()">
        <span>{{confirmAlertDialogOkText}}</span>
      </button>
    </div>
  </div>
</kendo-dialog>
<!-- DIALOG -->
